#include "mbed.h"
#include "AX12.h"

#define B 45                // Offset dimension
#define E 80                // Femur length
#define F 140               // Tibia length
#define X_OFFSET 25         // Distance from the X-axis -> servo centre
#define PI 3.14159

/************ Define Poses ************/
extern const int Stand[];
extern const int Sit[];
extern const int Walk[];
extern const int Step_Start[];

/********** Global structures **********/
struct Positions {
    int X_right;
    int Y_right;
    int Z_right;
    int X_left;
    int Y_left;
    int Z_left;
};

struct Joint_Angles {
    float lateral;
    float hip;
    float knee;
};

/**************************************************************************
Global variables
**************************************************************************/
extern AX12 Right_Hip_Lateral,
            Right_Hip,
            Right_Knee,
            Left_Hip_Lateral,
            Left_Hip,
            Left_Knee;

/********** Functions **********/
Positions FK_Engine();
void Set_Pose(const int *);
Joint_Angles IK_Engine(int, int, int);
void Walk_Forward(int);